#ifndef __OBSERVER_TEMPLATE_H__
#define __OBSERVER_TEMPLATE_H__

#include <list>

namespace vsip {

template <typename InputData> class Observer {
 public:
  virtual ~Observer(){}

  virtual void update(const InputData &i_message)=0;
};

template<typename InputData>
class Observable {
 public:
  virtual ~Observable(){}

  inline void notify(const InputData &i_message){
    typename std::list<Observer<InputData>*>::iterator it;
    
    for(it=m_observers.begin(); it!=m_observers.end(); it++)
      (*it)->update(i_message);
  }

  void attachObserver(Observer<InputData> *i_pO){
    m_observers.push_back(i_pO);
  }

  void detachObserver(Observer<InputData> *i_pO){
    m_observers.remove(i_pO);
  }

 private:
  std::list<Observer<InputData>* > m_observers;
};

} // end namespace vsip

#endif
