#ifndef SUPABSTRACTPROCESSDATAFLOWREADER_P_H
#define SUPABSTRACTPROCESSDATAFLOWREADER_P_H

#include "supAbstractProcess_p.h"
#include "supAbstractProcessDataReader.h"

#include <QFile>
#include <QDir>

class supAbstractProcessDataFlowReader;

////////////////////////////////////////////////////
// supAbstractProcessDataFlowReaderPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessDataFlowReaderPrivate : public supAbstractProcessPrivate
{
public:
    supAbstractProcessDataFlowReaderPrivate(supAbstractProcessDataFlowReader *q = 0) : supAbstractProcessPrivate(q) {
        m_dataReader = new supAbstractProcessDataReader();
    }
    supAbstractProcessDataFlowReaderPrivate(const supAbstractProcessDataFlowReaderPrivate& other) : supAbstractProcessPrivate(other) {}

public:
    virtual ~supAbstractProcessDataFlowReaderPrivate(void) {
        delete m_dataReader;
    }

public:
    // private members of the class are put here in the d-pointer, eg
    // int index;
    QFile m_file;
    supAbstractProcessDataReader * m_dataReader;
    QString m_dir;
};

////////////////////////////////////////////////////
// supAbstractProcessDataFlowReader protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessDataFlowReader, supAbstractProcess);

#endif
