#ifndef SUPABSTRACTPROCESSFAKETRACKER_H
#define SUPABSTRACTPROCESSFAKETRACKER_H

#include <supCore/supAbstractProcess.h>

#include <stdint.h>

#include "supCoreExport.h"

#include "supDataPhysicalObject.h"

#include "supDataActor.h"
#include "synchronizer.h"

#include <QSharedPointer>


class supAbstractProcessFakeTrackerPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessFakeTracker interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessFakeTracker : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessFakeTracker(void);
             supAbstractProcessFakeTracker(const supAbstractProcessFakeTracker& other);
    virtual ~supAbstractProcessFakeTracker(void);

public:
    virtual void setPhysicalObjs( const PhysicalObjs & physicalObjs);
    virtual const std::list <QSharedPointer <const supDataActor> > getActors() const;

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessFakeTracker);
};

#endif

