/* supAbstractProcessGroundDetection.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPABSTRACTPROCESSGROUNDDETECTION_H
#define SUPABSTRACTPROCESSGROUNDDETECTION_H

#include <supCore/supAbstractProcess.h>

#include "supCoreExport.h"
#include "supAbstractDataCalibrationWithDepth.h"

class supAbstractProcessGroundDetectionPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessGroundDetection interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessGroundDetection : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessGroundDetection(void);
             supAbstractProcessGroundDetection(const supAbstractProcessGroundDetection& other);
    virtual ~supAbstractProcessGroundDetection(void);

public:
    virtual supAbstractProcessGroundDetection *clone(void); // If your class is pure virtual you need to set this method to pure virtual too!

public:
    supAbstractProcessGroundDetection& operator = (const supAbstractProcessGroundDetection& other);

protected:
   virtual void copy(const dtkAbstractObject& other);

public:
   QString identifier(void) const;

public:

   virtual void setParameterFile (std::string fileName);


   virtual void computeGroundPlaneFromDepthMap ( cv::Mat depthMap );
   virtual void setCalibrationWithDepth ( supAbstractDataCalibrationWithDepth calibrationWithDepth );

   virtual std::vector<double> getGroundPlaneEquationCoef ();
   virtual std::list<cv::Point3f> getGroundPlanePoints ();

   virtual std::vector<double> getShiftedGroundPlaneEquationCoef (float shift);
   virtual std::list<cv::Point3f> getShiftedGroundPlanePoints (float shift);



public:


public:
    // Methods you want to overload from dtkAbstractdtkAbstractProcess

   // Try to sort in the alphabetical order

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessGroundDetection);
};

Q_DECLARE_METATYPE(supAbstractProcessGroundDetection)  // If your class is pure virtual, you cannot register to QMetatype.
Q_DECLARE_METATYPE(supAbstractProcessGroundDetection*) // Hence, you need to comment theses lines.

#endif

