/* supAbstractProcessJsonGenerator.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPABSTRACTPROCESSJSONGENERATOR_H
#define SUPABSTRACTPROCESSJSONGENERATOR_H

#include <supCore/supAbstractProcess.h>

#include "supCoreExport.h"
#include "supDataActor.h"
#include "supDataEvent.h"

class supAbstractProcessJsonGeneratorPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessJsonGenerator interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessJsonGenerator : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessJsonGenerator(void);
             supAbstractProcessJsonGenerator(const supAbstractProcessJsonGenerator& other);
    virtual ~supAbstractProcessJsonGenerator(void);

public:
    virtual supAbstractProcessJsonGenerator *clone(void); // If your class is pure virtual you need to set this method to pure virtual too! 

public:
    supAbstractProcessJsonGenerator& operator = (const supAbstractProcessJsonGenerator& other);

protected:
   virtual void copy(const dtkAbstractObject& other);

public:
   QString identifier(void) const;

public:

   virtual void setActors (std::list <QSharedPointer <const supDataActor > > actors);
   virtual void setEvents (std::list< QSharedPointer<supDataEvent> > events);
   virtual void setFrameNumber (int frameNumber);
   virtual void setTimestamp (qint64 timestamp);

public:
    // Add your own getter methods

    // Try to sort in the alphabetical order

public:
    // Methods you want to overload from dtkAbstractdtkAbstractProcess

   // Try to sort in the alphabetical order

public:

   virtual std::string generateJsonString ();

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessJsonGenerator);
};

Q_DECLARE_METATYPE(supAbstractProcessJsonGenerator)  // If your class is pure virtual, you cannot register to QMetatype.
Q_DECLARE_METATYPE(supAbstractProcessJsonGenerator*) // Hence, you need to comment theses lines.

#endif

