#ifndef SUPABSTRACTPROCESSXMLREADER_H
#define SUPABSTRACTPROCESSXMLREADER_H

#include "supAbstractProcess.h"

#include "supDataPhysicalObject.h"
#include "supDataActor.h"

#include "supCoreExport.h"

class supAbstractProcessXMLReaderWriterPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessXMLReaderWriter interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessXMLReaderWriter : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessXMLReaderWriter(void);
             supAbstractProcessXMLReaderWriter(const supAbstractProcessXMLReaderWriter& other);
    virtual ~supAbstractProcessXMLReaderWriter(void);

public: //Input
    void setInputXML (std::string i_pathToXML);
    void setOutputXML(std::string i_pathToXML);

public: //Process

    virtual bool writeFrameDataIntoXML(const std::list <QSharedPointer < const supDataActor> > &actors, const CSynchronizer & sync) = 0;
    virtual std::string getFrameDataAsXML(const std::list <QSharedPointer < const supDataActor> > &actors, const CSynchronizer & sync) = 0;
    virtual void closeXMLFile() = 0;

    virtual bool applyXMLReader() = 0;

public: //Output
    QList< QSharedPointer< supDataPhysicalObject > > getPhysicalObjectList(void);
    QList< QSharedPointer< supDataActor > > getActorList(void);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessXMLReaderWriter);
};

#endif
